import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import { Phases, symbol } from './constants';
import transformEvents from './transform-events';

var makeDummyEventStoreAdapter = function makeDummyEventStoreAdapter(_ref) {
  var secretsManager = _ref.secretsManager,
      events = _ref.events;
  return {
    getNextCursor: function getNextCursor() {
      return Promise.resolve(null);
    },
    saveSnapshot: function saveSnapshot() {
      return Promise.resolve();
    },
    getSecretsManager: function getSecretsManager() {
      return Promise.resolve(secretsManager);
    },
    loadSnapshot: function loadSnapshot() {
      return Promise.resolve(null);
    },
    loadEvents: function loadEvents() {
      return Promise.resolve({
        events: transformEvents(events, 'aggregate')
      });
    }
  };
};

var makeDummyPublisher = function makeDummyPublisher() {
  var savedEvents = [];
  return {
    savedEvents: savedEvents,
    publish: function () {
      var _publish = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(_ref2) {
        var event;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                event = _ref2.event;
                savedEvents.push(event);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function publish(_x) {
        return _publish.apply(this, arguments);
      }

      return publish;
    }()
  };
};

export var executeCommand = /*#__PURE__*/function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(context) {
    var createCommand, state, assertion, resolve, reject, executor, publisher, result;
    return _regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            createCommand = context.createCommand, state = context.promise[symbol];

            if (!(state.phase < Phases.COMMAND)) {
              _context2.next = 3;
              break;
            }

            throw new TypeError("unexpected phase");

          case 3:
            assertion = state.assertion, resolve = state.resolve, reject = state.reject;
            executor = null;
            _context2.prev = 5;
            publisher = makeDummyPublisher();
            executor = createCommand({
              eventstoreAdapter: makeDummyEventStoreAdapter(state),
              publisher: publisher,
              performanceTracer: null,
              aggregates: [{
                name: state.aggregate.name,
                projection: state.aggregate.projection,
                commands: state.aggregate.commands,
                encryption: state.aggregate.encryption || null,
                deserializeState: JSON.parse,
                serializeState: JSON.stringify,
                invariantHash: 'invariant-hash'
              }]
            });
            _context2.next = 10;
            return executor({
              aggregateId: 'test-aggregate-id',
              aggregateName: state.aggregate.name,
              type: state.command.name,
              payload: state.command.payload || {},
              jwt: state.jwt
            });

          case 10:
            result = _context2.sent;
            assertion(resolve, reject, {
              type: result.type,
              payload: result.payload
            }, null);
            _context2.next = 17;
            break;

          case 14:
            _context2.prev = 14;
            _context2.t0 = _context2["catch"](5);
            assertion(resolve, reject, null, _context2.t0);

          case 17:
            _context2.prev = 17;

            if (!executor) {
              _context2.next = 21;
              break;
            }

            _context2.next = 21;
            return executor.dispose();

          case 21:
            return _context2.finish(17);

          case 22:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[5, 14, 17, 22]]);
  }));

  return function executeCommand(_x2) {
    return _ref3.apply(this, arguments);
  };
}();
//# sourceMappingURL=execute-command.js.map